"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const MarkdownLeaf_1 = require("../MarkdownLeaf");
const utils_1 = require("../utils");
const withMarkdown_1 = require("../withMarkdown");
const tokens = [
    "strong",
    "em",
    "del",
    "codespan",
    "link",
    "h1",
    "h2",
    "h3",
    "h4",
    "h5",
    "h6",
    "marker",
];
function createMarkdownPlugin(options = {}) {
    return {
        name: "markdown",
        leave: {
            match: ({ leaf }) => tokens.some((key) => leaf[key]),
            component: options.component || MarkdownLeaf_1.default,
        },
        override: withMarkdown_1.default,
        decorate: utils_1.decorateMarkdown,
        handlers: { onKeyDown: { handler: utils_1.handleKeydown } },
        options,
    };
}
exports.default = createMarkdownPlugin;
